test/test
test/from_xml
test/from_xml_with_db
+ui/test/decoder
POTFILES
mkinstalldirs
stamp-it
lib_LTLIBRARIES = libgtkformui.la
-libgtkformui_la_SOURCES = gtkformdecoder.c
+libgtkformui_la_SOURCES = gtkformdecoder.c \
+ gtkformwidgetdecoder.c
libgtkformui_la_LDFLAGS = -no-undefined
-libgtkformui_include_HEADERS = gtkformdecoder.h
+libgtkformui_include_HEADERS = gtkformdecoder.h \
+ gtkformwidgetdecoder.h
libgtkformui_includedir = $(includedir)/libgtkformui
+
+install-exec-hook:
+ cd $(libdir)/$(PACKAGE)/modules && \
+ ln -s -f $(libdir)/libgtkformui.so .
+
+uninstall-hook:
+ rm -f $(libdir)/$(PACKAGE)/modules/libgtkdateentry.so
--- /dev/null
+/*
+ * Copyright (C) 2011 Andrea Zagli <azagli@libero.it>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <gtk/gtk.h>
+
+#include "gtkformdecoder.h"
+#include "gtkformwidgetdecoder.h"
+
+enum
+{
+ PROP_0
+};
+
+static void gtk_form_widget_decoder_class_init (GtkFormWidgetDecoderClass *klass);
+static void gtk_form_widget_decoder_init (GtkFormWidgetDecoder *gtk_form_widget_decoder);
+
+static void gtk_form_widget_decoder_set_property (GObject *object,
+ guint property_id,
+ const GValue *value,
+ GParamSpec *pspec);
+static void gtk_form_widget_decoder_get_property (GObject *object,
+ guint property_id,
+ GValue *value,
+ GParamSpec *pspec);
+
+#define GTK_FORM_WIDGET_DECODER_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), GTK_FORM_TYPE_WIDGET_DECODER, GtkFormWidgetDecoderPrivate))
+
+typedef struct _GtkFormWidgetDecoderPrivate GtkFormWidgetDecoderPrivate;
+struct _GtkFormWidgetDecoderPrivate
+ {
+ gpointer foo;
+ };
+
+
+G_DEFINE_TYPE (GtkFormWidgetDecoder, gtk_form_widget_decoder, TYPE_GTK_FORM_WIDGET)
+
+static void
+gtk_form_widget_decoder_class_init (GtkFormWidgetDecoderClass *klass)
+{
+ GObjectClass *object_class = G_OBJECT_CLASS (klass);
+ GtkFormWidgetClass *widget_class = GTK_FORM_WIDGET_CLASS (klass);
+
+ object_class->set_property = gtk_form_widget_decoder_set_property;
+ object_class->get_property = gtk_form_widget_decoder_get_property;
+
+ widget_class->get_value_stringify = gtk_form_widget_decoder_get_value_stringify;
+ widget_class->set_value_stringify = gtk_form_widget_decoder_set_value_stringify;
+ widget_class->set_editable = gtk_form_widget_decoder_set_editable;
+
+ g_type_class_add_private (object_class, sizeof (GtkFormWidgetDecoderPrivate));
+}
+
+static void
+gtk_form_widget_decoder_init (GtkFormWidgetDecoder *gtk_form_widget_decoder)
+{
+}
+
+/**
+ * gtk_form_widget_decoder_new:
+ *
+ * Returns: the newly created #GtkFormWidgetDecoder.
+ */
+GtkFormWidget
+*gtk_form_widget_decoder_new ()
+{
+ return g_object_new (gtk_form_widget_decoder_get_type (), NULL);
+}
+
+/**
+ * gtk_form_widget_decoder_get_value_stringify:
+ * @widget:
+ *
+ */
+gchar
+*gtk_form_widget_decoder_get_value_stringify (GtkFormWidget *fwidget)
+{
+ GtkFormWidgetDecoderPrivate *priv = GTK_FORM_WIDGET_DECODER_GET_PRIVATE (fwidget);
+
+ GtkWidget *w = gtk_form_widget_get_widget (fwidget);
+
+ return g_strdup (gtk_form_decoder_get_key (GTK_FORM_DECODER (w)));
+}
+
+/**
+ * gtk_form_widget_decoder_set_value_stringify:
+ * @fwidget:
+ * @value:
+ *
+ */
+gboolean
+gtk_form_widget_decoder_set_value_stringify (GtkFormWidget *fwidget, const gchar *value)
+{
+ gboolean ret = FALSE;
+ GtkWidget *w;
+
+ g_object_get (G_OBJECT (fwidget),
+ "widget", &w,
+ NULL);
+
+ gtk_form_decoder_set_key (GTK_FORM_DECODER (w), value);
+
+ ret = TRUE;
+
+ return ret;
+}
+
+/**
+ * gtk_form_widget_set_editable:
+ * @fwidget:
+ * @editable:
+ *
+ */
+void
+gtk_form_widget_decoder_set_editable (GtkFormWidget *fwidget, gboolean editable)
+{
+ GtkWidget *w;
+
+ g_object_get (G_OBJECT (fwidget),
+ "widget", &w,
+ NULL);
+
+ gtk_widget_set_sensitive (GTK_WIDGET (w), editable);
+}
+
+/* PRIVATE */
+static void
+gtk_form_widget_decoder_set_property (GObject *object,
+ guint property_id,
+ const GValue *value,
+ GParamSpec *pspec)
+{
+ GtkFormWidgetDecoder *widget_entry = (GtkFormWidgetDecoder *)object;
+
+ GtkFormWidgetDecoderPrivate *priv = GTK_FORM_WIDGET_DECODER_GET_PRIVATE (widget_entry);
+
+ switch (property_id)
+ {
+ default:
+ G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
+ break;
+ }
+}
+
+static void
+gtk_form_widget_decoder_get_property (GObject *object,
+ guint property_id,
+ GValue *value,
+ GParamSpec *pspec)
+{
+ GtkFormWidgetDecoder *widget_entry = (GtkFormWidgetDecoder *)object;
+
+ GtkFormWidgetDecoderPrivate *priv = GTK_FORM_WIDGET_DECODER_GET_PRIVATE (widget_entry);
+
+ switch (property_id)
+ {
+ default:
+ G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
+ break;
+ }
+}
--- /dev/null
+/*
+ * Copyright (C) 2011 Andrea Zagli <azagli@libero.it>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef __LIBGTK_FORM_WIDGET_DECODER_H__
+#define __LIBGTK_FORM_WIDGET_DECODER_H__
+
+#include <libgtkform/widget.h>
+
+
+G_BEGIN_DECLS
+
+
+#define GTK_FORM_TYPE_WIDGET_DECODER (gtk_form_widget_decoder_get_type ())
+#define GTK_FORM_WIDGET_DECODER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_FORM_TYPE_WIDGET_DECODER, GtkFormWidgetDecoder))
+#define GTK_FORM_WIDGET_DECODER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_FORM_TYPE_WIDGET_DECODER, GtkFormWidgetDecoderClass))
+#define GTK_FORM_IS_WIDGET_DECODER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_FORM_TYPE_WIDGET_DECODER))
+#define GTK_FORM_IS_WIDGET_DECODER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_FORM_TYPE_WIDGET_DECODER))
+#define GTK_FORM_WIDGET_DECODER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_FORM_TYPE_WIDGET_DECODER, GtkFormWidgetDecoderClass))
+
+
+typedef struct _GtkFormWidgetDecoder GtkFormWidgetDecoder;
+typedef struct _GtkFormWidgetDecoderClass GtkFormWidgetDecoderClass;
+
+struct _GtkFormWidgetDecoder
+ {
+ GtkFormWidget parent;
+ };
+
+struct _GtkFormWidgetDecoderClass
+ {
+ GtkFormWidgetClass parent_class;
+ };
+
+GType gtk_form_widget_decoder_get_type (void) G_GNUC_CONST;
+
+GtkFormWidget *gtk_form_widget_decoder_new (void);
+
+gchar *gtk_form_widget_decoder_get_value_stringify (GtkFormWidget *widget);
+
+gboolean gtk_form_widget_decoder_set_value_stringify (GtkFormWidget *fwidget, const gchar *value);
+
+void gtk_form_widget_decoder_set_editable (GtkFormWidget *fwidget, gboolean editable);
+
+
+G_END_DECLS
+
+
+#endif /* __LIBGTK_FORM_WIDGET_DECODER_H__ */
+++ /dev/null
-#! /bin/bash
-
-# decoder - temporary wrapper script for .libs/decoder
-# Generated by libtool (GNU libtool) 2.4 Debian-2.4-2
-#
-# The decoder program cannot be directly executed until all the libtool
-# libraries that it depends on are installed.
-#
-# This wrapper script should never be moved out of the build directory.
-# If it is, it will not operate correctly.
-
-# Sed substitution that helps us do robust quoting. It backslashifies
-# metacharacters that are still active within double-quoted strings.
-sed_quote_subst='s/\([`"$\\]\)/\\\1/g'
-
-# Be Bourne compatible
-if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
- emulate sh
- NULLCMD=:
- # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
- # is contrary to our usage. Disable this feature.
- alias -g '${1+"$@"}'='"$@"'
- setopt NO_GLOB_SUBST
-else
- case `(set -o) 2>/dev/null` in *posix*) set -o posix;; esac
-fi
-BIN_SH=xpg4; export BIN_SH # for Tru64
-DUALCASE=1; export DUALCASE # for MKS sh
-
-# The HP-UX ksh and POSIX shell print the target directory to stdout
-# if CDPATH is set.
-(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
-
-relink_command="(cd /home/andreaz/files/c/libgtkform/ui/test; { test -z \"\${LIBRARY_PATH+set}\" || unset LIBRARY_PATH || { LIBRARY_PATH=; export LIBRARY_PATH; }; }; { test -z \"\${COMPILER_PATH+set}\" || unset COMPILER_PATH || { COMPILER_PATH=; export COMPILER_PATH; }; }; { test -z \"\${GCC_EXEC_PREFIX+set}\" || unset GCC_EXEC_PREFIX || { GCC_EXEC_PREFIX=; export GCC_EXEC_PREFIX; }; }; { test -z \"\${LD_RUN_PATH+set}\" || unset LD_RUN_PATH || { LD_RUN_PATH=; export LD_RUN_PATH; }; }; { test -z \"\${LD_LIBRARY_PATH+set}\" || unset LD_LIBRARY_PATH || { LD_LIBRARY_PATH=; export LD_LIBRARY_PATH; }; }; PATH=/usr/local/bin:/usr/bin:/bin:/usr/local/games:/usr/games; export PATH; gcc -g -O2 -o \$progdir/\$file decoder.o -pthread -Wl,--export-dynamic ../../src/.libs/libgtkform.so ../../ui/.libs/libgtkformui.so -L/usr/local/lib /usr/lib/libgtk-x11-2.0.so /usr/lib/libgdk-x11-2.0.so /usr/lib/libatk-1.0.so /usr/lib/libgio-2.0.so /usr/lib/libpangoft2-1.0.so /usr/lib/libpangocairo-1.0.so /usr/lib/libgdk_pixbuf-2.0.so -lm /usr/lib/libcairo.so /usr/lib/libpango-1.0.so /usr/lib/libfreetype.so -lfontconfig /usr/lib/libgmodule-2.0.so /usr/local/lib/libgdaex.so /usr/local/lib/libgda-4.0.so /usr/lib/libgobject-2.0.so /usr/lib/libxml2.so /usr/lib/libgthread-2.0.so -lrt /usr/lib/libglib-2.0.so -pthread -Wl,-rpath -Wl,/home/andreaz/files/c/libgtkform/src/.libs -Wl,-rpath -Wl,/home/andreaz/files/c/libgtkform/ui/.libs)"
-
-# This environment variable determines our operation mode.
-if test "$libtool_install_magic" = "%%%MAGIC variable%%%"; then
- # install mode needs the following variables:
- generated_by_libtool_version='2.4'
- notinst_deplibs=' ../../src/libgtkform.la ../../ui/libgtkformui.la'
-else
- # When we are sourced in execute mode, $file and $ECHO are already set.
- if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
- file="$0"
-
-# A function that is used when there is no print builtin or printf.
-func_fallback_echo ()
-{
- eval 'cat <<_LTECHO_EOF
-$1
-_LTECHO_EOF'
-}
- ECHO="printf %s\\n"
- fi
-
-# Very basic option parsing. These options are (a) specific to
-# the libtool wrapper, (b) are identical between the wrapper
-# /script/ and the wrapper /executable/ which is used only on
-# windows platforms, and (c) all begin with the string --lt-
-# (application programs are unlikely to have options which match
-# this pattern).
-#
-# There are only two supported options: --lt-debug and
-# --lt-dump-script. There is, deliberately, no --lt-help.
-#
-# The first argument to this parsing function should be the
-# script's ../../libtool value, followed by no.
-lt_option_debug=
-func_parse_lt_options ()
-{
- lt_script_arg0=$0
- shift
- for lt_opt
- do
- case "$lt_opt" in
- --lt-debug) lt_option_debug=1 ;;
- --lt-dump-script)
- lt_dump_D=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%/[^/]*$%%'`
- test "X$lt_dump_D" = "X$lt_script_arg0" && lt_dump_D=.
- lt_dump_F=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%^.*/%%'`
- cat "$lt_dump_D/$lt_dump_F"
- exit 0
- ;;
- --lt-*)
- $ECHO "Unrecognized --lt- option: '$lt_opt'" 1>&2
- exit 1
- ;;
- esac
- done
-
- # Print the debug banner immediately:
- if test -n "$lt_option_debug"; then
- echo "decoder:decoder:${LINENO}: libtool wrapper (GNU libtool) 2.4 Debian-2.4-2" 1>&2
- fi
-}
-
-# Used when --lt-debug. Prints its arguments to stdout
-# (redirection is the responsibility of the caller)
-func_lt_dump_args ()
-{
- lt_dump_args_N=1;
- for lt_arg
- do
- $ECHO "decoder:decoder:${LINENO}: newargv[$lt_dump_args_N]: $lt_arg"
- lt_dump_args_N=`expr $lt_dump_args_N + 1`
- done
-}
-
-# Core function for launching the target application
-func_exec_program_core ()
-{
-
- if test -n "$lt_option_debug"; then
- $ECHO "decoder:decoder:${LINENO}: newargv[0]: $progdir/$program" 1>&2
- func_lt_dump_args ${1+"$@"} 1>&2
- fi
- exec "$progdir/$program" ${1+"$@"}
-
- $ECHO "$0: cannot exec $program $*" 1>&2
- exit 1
-}
-
-# A function to encapsulate launching the target application
-# Strips options in the --lt-* namespace from $@ and
-# launches target application with the remaining arguments.
-func_exec_program ()
-{
- for lt_wr_arg
- do
- case $lt_wr_arg in
- --lt-*) ;;
- *) set x "$@" "$lt_wr_arg"; shift;;
- esac
- shift
- done
- func_exec_program_core ${1+"$@"}
-}
-
- # Parse options
- func_parse_lt_options "$0" ${1+"$@"}
-
- # Find the directory that this script lives in.
- thisdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
- test "x$thisdir" = "x$file" && thisdir=.
-
- # Follow symbolic links until we get to the real thisdir.
- file=`ls -ld "$file" | /bin/sed -n 's/.*-> //p'`
- while test -n "$file"; do
- destdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
-
- # If there was a directory component, then change thisdir.
- if test "x$destdir" != "x$file"; then
- case "$destdir" in
- [\\/]* | [A-Za-z]:[\\/]*) thisdir="$destdir" ;;
- *) thisdir="$thisdir/$destdir" ;;
- esac
- fi
-
- file=`$ECHO "$file" | /bin/sed 's%^.*/%%'`
- file=`ls -ld "$thisdir/$file" | /bin/sed -n 's/.*-> //p'`
- done
-
- # Usually 'no', except on cygwin/mingw when embedded into
- # the cwrapper.
- WRAPPER_SCRIPT_BELONGS_IN_OBJDIR=no
- if test "$WRAPPER_SCRIPT_BELONGS_IN_OBJDIR" = "yes"; then
- # special case for '.'
- if test "$thisdir" = "."; then
- thisdir=`pwd`
- fi
- # remove .libs from thisdir
- case "$thisdir" in
- *[\\/].libs ) thisdir=`$ECHO "$thisdir" | /bin/sed 's%[\\/][^\\/]*$%%'` ;;
- .libs ) thisdir=. ;;
- esac
- fi
-
- # Try to get the absolute directory name.
- absdir=`cd "$thisdir" && pwd`
- test -n "$absdir" && thisdir="$absdir"
-
- program=lt-'decoder'
- progdir="$thisdir/.libs"
-
- if test ! -f "$progdir/$program" ||
- { file=`ls -1dt "$progdir/$program" "$progdir/../$program" 2>/dev/null | /bin/sed 1q`; \
- test "X$file" != "X$progdir/$program"; }; then
-
- file="$$-$program"
-
- if test ! -d "$progdir"; then
- mkdir "$progdir"
- else
- rm -f "$progdir/$file"
- fi
-
- # relink executable if necessary
- if test -n "$relink_command"; then
- if relink_command_output=`eval $relink_command 2>&1`; then :
- else
- printf %s\n "$relink_command_output" >&2
- rm -f "$progdir/$file"
- exit 1
- fi
- fi
-
- mv -f "$progdir/$file" "$progdir/$program" 2>/dev/null ||
- { rm -f "$progdir/$program";
- mv -f "$progdir/$file" "$progdir/$program"; }
- rm -f "$progdir/$file"
- fi
-
- if test -f "$progdir/$program"; then
- if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
- # Run the actual program with our arguments.
- func_exec_program ${1+"$@"}
- fi
- else
- # The program doesn't exist.
- $ECHO "$0: error: \`$progdir/$program' does not exist" 1>&2
- $ECHO "This script is just a wrapper for $program." 1>&2
- $ECHO "See the libtool documentation for more information." 1>&2
- exit 1
- fi
-fi